package org.jeecg.modules.database.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.database.dto.ExperimentRatingUserDTO;
import org.jeecg.modules.database.entity.Experiment;
import org.jeecg.modules.database.entity.ExperimentRating;
import org.jeecg.modules.database.service.IExperimentRatingService;
import org.jeecg.modules.database.service.IExperimentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * @Description: 试验评分
 * @Author: jeecg-boot
 * @Date: 2024-11-16
 * @Version: V1.0
 */
@Tag(name = "试验评分")
@RestController
@RequestMapping("/database/experimentRating")
@Slf4j
public class ExperimentRatingController extends JeecgController<ExperimentRating, IExperimentRatingService> {
    @Autowired
    private IExperimentRatingService experimentRatingService;

    @Autowired
    private IExperimentService experimentService;

    /**
     * 分页列表查询
     *
     * @param experimentRating
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "试验评分-分页列表查询")
    @Operation(summary = "试验评分-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<ExperimentRating>> queryPageList(ExperimentRating experimentRating,
                                                         @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                         @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                         HttpServletRequest req) {
        QueryWrapper<ExperimentRating> queryWrapper = QueryGenerator.initQueryWrapper(experimentRating, req.getParameterMap());
        Page<ExperimentRating> page = new Page<ExperimentRating>(pageNo, pageSize);
        IPage<ExperimentRating> pageList = experimentRatingService.page(page, queryWrapper);
        pageList.getRecords().forEach(v -> experimentService.fetchExperimentRateDetail(v));
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param experimentRating
     * @return
     */
    @AutoLog(value = "试验评分-添加")
    @Operation(summary = "试验评分-添加")
    @RequiresPermissions("database:experiment_rating:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody ExperimentRating experimentRating) {
        String experimentId = experimentRating.getExperimentId();
        if (StringUtils.isBlank(experimentId)) {
            return Result.error("试验数据不存在！");
        }
        Experiment experiment = experimentService.getById(experimentId);
        if (Objects.isNull(experiment)) {
            return Result.error("试验数据不存在！");
        }
        if (StringUtils.isBlank(experimentRating.getRateUserId())) {
            return Result.error("评分人员不能为空！");
        }
        experimentRatingService.save(experimentRating);
        return Result.OK("添加成功！");
    }

    /**
     * 添加
     *
     * @param experimentRating
     * @return
     */
    @AutoLog(value = "试验评分-批量添加")
    @Operation(summary = "试验评分-批量添加")
    @RequiresPermissions("database:experiment_rating:add")
    @PostMapping(value = "/addAll")
    public Result<String> batchAdd(@RequestBody ExperimentRating experimentRating) {
        String experimentId = experimentRating.getExperimentId();
        if (StringUtils.isBlank(experimentId)) {
            return Result.error("试验数据不存在！");
        }
        Experiment experiment = experimentService.getById(experimentId);
        if (Objects.isNull(experiment)) {
            return Result.error("试验数据不存在！");
        }
        List<ExperimentRatingUserDTO> rateUserList = experimentRating.getRateUserList();
        if (rateUserList.isEmpty()) {
            return Result.error("评分人员不能为空！");
        }
        rateUserList.forEach(v -> {
            ExperimentRating er = new ExperimentRating();
            er.setExperimentId(experimentId);
            er.setRateUserId(v.getRateUserId());
            er.setBaseScore(v.getBaseScore());
            er.setCompletionScore(v.getCompletionScore());
            er.setTotalScore(v.getTotalScore());
            er.setManagementScore(v.getManagementScore());
            er.setDifficultyScore(v.getDifficultyScore());
            experimentRatingService.save(er);
        });

        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param experimentRating
     * @return
     */
    @AutoLog(value = "试验评分-编辑")
    @Operation(summary = "试验评分-编辑")
    @RequiresPermissions("database:experiment_rating:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody ExperimentRating experimentRating) {
        experimentRatingService.updateById(experimentRating);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "试验评分-通过id删除")
    @Operation(summary = "试验评分-通过id删除")
    @RequiresPermissions("database:experiment_rating:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        experimentRatingService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "试验评分-批量删除")
    @Operation(summary = "试验评分-批量删除")
    @RequiresPermissions("database:experiment_rating:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.experimentRatingService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "试验评分-通过id查询")
    @Operation(summary = "试验评分-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<ExperimentRating> queryById(@RequestParam(name = "id", required = true) String id) {
        ExperimentRating experimentRating = experimentRatingService.getById(id);
        if (experimentRating == null) {
            return Result.error("未找到对应数据");
        }
        experimentService.fetchExperimentRateDetail(experimentRating);
        return Result.OK(experimentRating);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param experimentRating
     */

    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ExperimentRating experimentRating) {
        return super.exportXls(request, experimentRating, ExperimentRating.class, "试验评分");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:experiment_rating:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ExperimentRating.class);
    }

}
